diff --git a/doc/src/sgml/rules.sgml b/doc/src/sgml/rules.sgml
index ffe208c..de28949 100644
--- a/doc/src/sgml/rules.sgml
+++ b/doc/src/sgml/rules.sgml
@@ -1,27 +1,27 @@
 <!-- $PostgreSQL$ -->
 
-<Chapter Id="rules">
-<Title>The Rule System</Title>
+<chapter id="rules">
+<title>The Rule System</title>
 
  <indexterm zone="rules">
   <primary>rule</primary>
  </indexterm>
 
-<Para>
+<para>
      This chapter discusses the rule system in
      <productname>PostgreSQL</productname>.  Production rule systems
      are conceptually simple, but there are many subtle points
      involved in actually using them.
-</Para>
+</para>
 
-<Para>
+<para>
      Some other database systems define active database rules, which
      are usually stored procedures and triggers.  In
      <productname>PostgreSQL</productname>, these can be implemented
      using functions and triggers as well.
-</Para>
+</para>
 
-<Para>
+<para>
      The rule system (more precisely speaking, the query rewrite rule
      system) is totally different from stored procedures and triggers.
      It modifies queries to take rules into consideration, and then
@@ -33,31 +33,31 @@
      linkend="ONG90">.
 </para>
 
-<Sect1 id="querytree">
-<Title>The Query Tree</Title>
+<sect1 id="querytree">
+<title>The Query Tree</title>
 
 <indexterm zone="querytree">
  <primary>query tree</primary>
 </indexterm>
 
-<Para>
+<para>
     To understand how the rule system works it is necessary to know
     when it is invoked and what its input and results are.
-</Para>
+</para>
 
-<Para>
+<para>
     The rule system is located between the parser and the planner.
     It takes the output of the parser, one query tree, and the user-defined
     rewrite rules, which are also
     query trees with some extra information, and creates zero or more
     query trees as result. So its input and output are always things
     the parser itself could have produced and thus, anything it sees
-    is basically representable as an <Acronym>SQL</Acronym> statement.
-</Para>
+    is basically representable as an <acronym>SQL</acronym> statement.
+</para>
 
-<Para>
+<para>
     Now what is a query tree? It is an internal representation of an
-    <Acronym>SQL</Acronym> statement where the single parts that it is
+    <acronym>SQL</acronym> statement where the single parts that it is
     built from are stored separately. These query trees can be shown
     in the server log if you set the configuration parameters
     <varname>debug_print_parse</varname>,
@@ -66,94 +66,94 @@
     stored as query trees, in the system catalog
     <structname>pg_rewrite</structname>.  They are not formatted like
     the log output, but they contain exactly the same information.
-</Para>
+</para>
 
-<Para>
+<para>
     Reading a raw query tree requires some experience.  But since
-    <Acronym>SQL</Acronym> representations of query trees are
+    <acronym>SQL</acronym> representations of query trees are
     sufficient to understand the rule system, this chapter will not
     teach how to read them.
-</Para>
+</para>
 
-<Para>
-    When reading the <Acronym>SQL</Acronym> representations of the 
+<para>
+    When reading the <acronym>SQL</acronym> representations of the 
     query trees in this chapter it is necessary to be able to identify
     the parts the statement is broken into when it is in the query tree
     structure. The parts of a query tree are
 
-<VariableList>
-    <VarListEntry>
-    <Term>
+<variablelist>
+    <varlistentry>
+    <term>
         the command type
-    </Term>
-    <ListItem>
-    <Para>
+    </term>
+    <listitem>
+    <para>
         This is a simple value telling which command
         (<command>SELECT</command>, <command>INSERT</command>,
         <command>UPDATE</command>, <command>DELETE</command>) produced
         the query tree.
-    </Para>
-    </ListItem>
-    </VarListEntry>
+    </para>
+    </listitem>
+    </varlistentry>
 
-    <VarListEntry>
-    <Term>
+    <varlistentry>
+    <term>
         the range table
-    </Term>
+    </term>
       <indexterm><primary>range table</></>
-    <ListItem>
-    <Para>
+    <listitem>
+    <para>
         The range table is a list of relations that are used in the query.
         In a <command>SELECT</command> statement these are the relations given after
         the <literal>FROM</literal> key word.
-    </Para>
+    </para>
 
-    <Para>
+    <para>
         Every range table entry identifies a table or view and tells
         by which name it is called in the other parts of the query.
         In the query tree, the range table entries are referenced by
         number rather than by name, so here it doesn't matter if there
-        are duplicate names as it would in an <Acronym>SQL</Acronym>
+        are duplicate names as it would in an <acronym>SQL</acronym>
         statement. This can happen after the range tables of rules
         have been merged in. The examples in this chapter will not have
         this situation.
-    </Para>
-    </ListItem>
-    </VarListEntry>
+    </para>
+    </listitem>
+    </varlistentry>
 
-    <VarListEntry>
-    <Term>
+    <varlistentry>
+    <term>
         the result relation
-    </Term>
-    <ListItem>
-    <Para>
+    </term>
+    <listitem>
+    <para>
         This is an index into the range table that identifies the
         relation where the results of the query go.
-    </Para>
+    </para>
 
-    <Para>
+    <para>
         <command>SELECT</command> queries normally don't have a result
         relation. The special case of a <command>SELECT INTO</command> is
         mostly identical to a <command>CREATE TABLE</command> followed by a
         <literal>INSERT ... SELECT</literal> and is not discussed
         separately here.
-    </Para>
+    </para>
 
-    <Para>
+    <para>
         For <command>INSERT</command>, <command>UPDATE</command>, and
         <command>DELETE</command> commands, the result relation is the table
         (or view!) where the changes are to take effect.
-    </Para>
-    </ListItem>
-    </VarListEntry>
+    </para>
+    </listitem>
+    </varlistentry>
 
-    <VarListEntry>
-    <Term>
+    <varlistentry>
+    <term>
         the target list
-    </Term>
+    </term>
     <indexterm><primary>target list</></>
-    <ListItem>
-    <Para>
+    <listitem>
+    <para>
         The target list is a list of expressions that define the
         result of the query.  In the case of a
         <command>SELECT</command>, these expressions are the ones that
@@ -163,17 +163,17 @@
         abbreviation for all the column names of a relation.  It is
         expanded by the parser into the individual columns, so the
         rule system never sees it.)
-    </Para>
+    </para>
 
-    <Para>
+    <para>
         <command>DELETE</command> commands don't need a target list
         because they don't produce any result. In fact, the planner will
         add a special <acronym>CTID</> entry to the empty target list, but
         this is after the rule system and will be discussed later; for the
         rule system, the target list is empty.
-    </Para>
+    </para>
 
-    <Para>
+    <para>
         For <command>INSERT</command> commands, the target list describes
         the new rows that should go into the result relation. It consists of the
         expressions in the <literal>VALUES</> clause or the ones from the
@@ -183,9 +183,9 @@
         the original command but have defaults.  Any remaining columns (with
         neither a given value nor a default) will be filled in by the
         planner with a constant null expression.
-    </Para>
+    </para>
 
-    <Para>
+    <para>
         For <command>UPDATE</command> commands, the target list
         describes the new rows that should replace the old ones. In the
         rule system, it contains just the expressions from the <literal>SET
@@ -193,40 +193,40 @@
         missing columns by inserting expressions that copy the values from
         the old row into the new one. And it will add the special
         <acronym>CTID</> entry just as for <command>DELETE</command>, too.
-    </Para>
+    </para>
 
-    <Para>
+    <para>
         Every entry in the target list contains an expression that can
         be a constant value, a variable pointing to a column of one
         of the relations in the range table, a parameter, or an expression
         tree made of function calls, constants, variables, operators, etc.
-    </Para>
-    </ListItem>
-    </VarListEntry>
+    </para>
+    </listitem>
+    </varlistentry>
 
-    <VarListEntry>
-    <Term>
+    <varlistentry>
+    <term>
         the qualification
-    </Term>
-    <ListItem>
-    <Para>
+    </term>
+    <listitem>
+    <para>
         The query's qualification is an expression much like one of
         those contained in the target list entries. The result value of
         this expression is a Boolean that tells whether the operation
         (<command>INSERT</command>, <command>UPDATE</command>,
         <command>DELETE</command>, or <command>SELECT</command>) for the
         final result row should be executed or not. It corresponds to the <literal>WHERE</> clause
-        of an <Acronym>SQL</Acronym> statement.
-    </Para>
-    </ListItem>
-    </VarListEntry>
+        of an <acronym>SQL</acronym> statement.
+    </para>
+    </listitem>
+    </varlistentry>
 
-    <VarListEntry>
-    <Term>
+    <varlistentry>
+    <term>
         the join tree
-    </Term>
-    <ListItem>
-    <Para>
+    </term>
+    <listitem>
+    <para>
         The query's join tree shows the structure of the <literal>FROM</> clause.
         For a simple query like <literal>SELECT ... FROM a, b, c</literal>, the join tree is just
         a list of the <literal>FROM</> items, because we are allowed to join them in
@@ -239,31 +239,31 @@
         the top-level <literal>WHERE</> expression as a qualification attached to the
         top-level join-tree item, too.  So really the join tree represents
         both the <literal>FROM</> and <literal>WHERE</> clauses of a <command>SELECT</command>.
-    </Para>
-    </ListItem>
-    </VarListEntry>
+    </para>
+    </listitem>
+    </varlistentry>
 
-    <VarListEntry>
-    <Term>
+    <varlistentry>
+    <term>
         the others
-    </Term>
-    <ListItem>
-    <Para>
+    </term>
+    <listitem>
+    <para>
         The other parts of the query tree like the <literal>ORDER BY</>
         clause aren't of interest here. The rule system
         substitutes some entries there while applying rules, but that
         doesn't have much to do with the fundamentals of the rule
         system.
-    </Para>
-    </ListItem>
-    </VarListEntry>
+    </para>
+    </listitem>
+    </varlistentry>
 
-</VariableList>
+</variablelist>
 </para>
-</Sect1>
+</sect1>
 
-<Sect1 id="rules-views">
-<Title>Views and the Rule System</Title>
+<sect1 id="rules-views">
+<title>Views and the Rule System</title>
 
 <indexterm zone="rules-views">
  <primary>rule</primary>
@@ -275,57 +275,57 @@
  <secondary>implementation through rules</>
 </indexterm>
 
-<Para>
-    Views in <ProductName>PostgreSQL</ProductName> are implemented
+<para>
+    Views in <productname>PostgreSQL</productname> are implemented
     using the rule system. In fact, there is essentially no difference
     between
 
-<ProgramListing>
+<programlisting>
 CREATE VIEW myview AS SELECT * FROM mytab;
-</ProgramListing>
+</programlisting>
     
     compared against the two commands
 
-<ProgramListing>
-CREATE TABLE myview (<Replaceable>same column list as mytab</Replaceable>);
+<programlisting>
+CREATE TABLE myview (<replaceable>same column list as mytab</replaceable>);
 CREATE RULE "_RETURN" AS ON SELECT TO myview DO INSTEAD
     SELECT * FROM mytab;
-</ProgramListing>
+</programlisting>
     
     because this is exactly what the <command>CREATE VIEW</command>
     command does internally.  This has some side effects. One of them
     is that the information about a view in the
-    <ProductName>PostgreSQL</ProductName> system catalogs is exactly
+    <productname>PostgreSQL</productname> system catalogs is exactly
     the same as it is for a table. So for the parser, there is
     absolutely no difference between a table and a view. They are the
     same thing: relations.
-</Para>
+</para>
 
-<Sect2 id="rules-select">
-<Title>How <command>SELECT</command> Rules Work</Title>
+<sect2 id="rules-select">
+<title>How <command>SELECT</command> Rules Work</title>
 
 <indexterm zone="rules-select">
  <primary>rule</primary>
  <secondary sortas="SELECT">for SELECT</secondary>
 </indexterm>
 
-<Para>
+<para>
     Rules <literal>ON SELECT</> are applied to all queries as the last step, even
     if the command given is an <command>INSERT</command>,
     <command>UPDATE</command> or <command>DELETE</command>. And they
     have different semantics from rules on the other command types in that they modify the
     query tree in place instead of creating a new one.  So
     <command>SELECT</command> rules are described first.
-</Para>
+</para>
 
-<Para>
+<para>
     Currently, there can be only one action in an <literal>ON SELECT</> rule, and it must
     be an unconditional <command>SELECT</> action that is <literal>INSTEAD</>. This restriction was
     required to make rules safe enough to open them for ordinary users, and
     it restricts <literal>ON SELECT</> rules to act like views.
-</Para>
+</para>
 
-<Para>
+<para>
     The examples for this chapter are two join views that do some
     calculations and some more views using them in turn.  One of the
     two first views is customized later by adding rules for
@@ -336,24 +336,24 @@ CREATE RULE "_RETURN" AS ON SELECT TO myview DO INSTEAD
     this makes things harder to get into. But it's better to have one
     example that covers all the points discussed step by step rather
     than having many different ones that might mix up in mind.
-</Para>
+</para>
 
-<Para>
+<para>
 For the example, we need a little <literal>min</literal> function that
 returns the lower of 2 integer values. We create that as
 
-<ProgramListing>
+<programlisting>
 CREATE FUNCTION min(integer, integer) RETURNS integer AS $$
-    SELECT CASE WHEN $1 < $2 THEN $1 ELSE $2 END
+    SELECT CASE WHEN $1 &lt; $2 THEN $1 ELSE $2 END
 $$ LANGUAGE SQL STRICT;
-</ProgramListing>
-</Para>
+</programlisting>
+</para>
 
-<Para>
+<para>
     The real tables we need in the first two rule system descriptions
     are these:
 
-<ProgramListing>
+<programlisting>
 CREATE TABLE shoe_data (
     shoename   text,          -- primary key
     sh_avail   integer,       -- available number of pairs
@@ -375,15 +375,15 @@ CREATE TABLE unit (
     un_name    text,          -- primary key
     un_fact    real           -- factor to transform to cm
 );
-</ProgramListing>
+</programlisting>
 
     As you can see, they represent shoe-store data.
-</Para>
+</para>
 
-<Para>
+<para>
     The views are created as
 
-<ProgramListing>
+<programlisting>
 CREATE VIEW shoe AS
     SELECT sh.shoename,
            sh.sh_avail,
@@ -414,9 +414,9 @@ CREATE VIEW shoe_ready AS
            min(rsh.sh_avail, rsl.sl_avail) AS total_avail
       FROM shoe rsh, shoelace rsl
      WHERE rsl.sl_color = rsh.slcolor
-       AND rsl.sl_len_cm >= rsh.slminlen_cm
-       AND rsl.sl_len_cm <= rsh.slmaxlen_cm;
-</ProgramListing>
+       AND rsl.sl_len_cm &gt;= rsh.slminlen_cm
+       AND rsl.sl_len_cm &lt;= rsh.slmaxlen_cm;
+</programlisting>
 
     The <command>CREATE VIEW</command> command for the
     <literal>shoelace</literal> view (which is the simplest one we
@@ -430,23 +430,23 @@ CREATE VIEW shoe_ready AS
     The action of our rule has a query qualification.
     The action of the rule is one query tree that is a copy of the
     <command>SELECT</command> statement in the view creation command.
-</Para>
+</para>
     
-    <Note>
-    <Para>
+    <note>
+    <para>
     The two extra range
     table entries for <literal>NEW</> and <literal>OLD</> (named <literal>*NEW*</> and <literal>*OLD*</> for
     historical reasons in the printed query tree) you can see in
     the <structname>pg_rewrite</structname> entry aren't of interest
     for <command>SELECT</command> rules.
-    </Para>
-    </Note>
+    </para>
+    </note>
 
-<Para>
+<para>
     Now we populate <literal>unit</literal>, <literal>shoe_data</literal>
     and <literal>shoelace_data</literal> and run a simple query on a view:
 
-<ProgramListing>
+<programlisting>
 INSERT INTO unit VALUES ('cm', 1.0);
 INSERT INTO unit VALUES ('m', 100.0);
 INSERT INTO unit VALUES ('inch', 2.54);
@@ -478,7 +478,7 @@ SELECT * FROM shoelace;
  sl5       |        4 | brown    |      1 | m       |       100
  sl6       |        0 | brown    |    0.9 | m       |        90
 (8 rows)
-</ProgramListing>
+</programlisting>
    </para>
 
    <para>
@@ -487,12 +487,12 @@ SELECT * FROM shoelace;
     rules.  The <literal>SELECT * FROM shoelace</literal> was
     interpreted by the parser and produced the query tree
 
-<ProgramListing>
+<programlisting>
 SELECT shoelace.sl_name, shoelace.sl_avail,
        shoelace.sl_color, shoelace.sl_len,
        shoelace.sl_unit, shoelace.sl_len_cm
   FROM shoelace shoelace;
-</ProgramListing>
+</programlisting>
 
     and this is given to the rule system. The rule system walks through the
     range table and checks if there are rules
@@ -500,23 +500,23 @@ SELECT shoelace.sl_name, shoelace.sl_avail,
     <literal>shoelace</literal> (the only one up to now) it finds the
     <literal>_RETURN</literal> rule with the query tree
 
-<ProgramListing>
+<programlisting>
 SELECT s.sl_name, s.sl_avail,
        s.sl_color, s.sl_len, s.sl_unit,
        s.sl_len * u.un_fact AS sl_len_cm
   FROM shoelace *OLD*, shoelace *NEW*,
        shoelace_data s, unit u
  WHERE s.sl_unit = u.un_name;
-</ProgramListing>
-</Para>
+</programlisting>
+</para>
 
-<Para>
+<para>
     To expand the view, the rewriter simply creates a subquery range-table
     entry containing the rule's action query tree, and substitutes this
     range table entry for the original one that referenced the view.  The 
     resulting rewritten query tree is almost the same as if you had typed
 
-<ProgramListing>
+<programlisting>
 SELECT shoelace.sl_name, shoelace.sl_avail,
        shoelace.sl_color, shoelace.sl_len,
        shoelace.sl_unit, shoelace.sl_len_cm
@@ -528,7 +528,7 @@ SELECT shoelace.sl_name, shoelace.sl_avail,
                s.sl_len * u.un_fact AS sl_len_cm
           FROM shoelace_data s, unit u
          WHERE s.sl_unit = u.un_name) shoelace;
-</ProgramListing>
+</programlisting>
 
      There is one difference however: the subquery's range table has two
      extra entries <literal>shoelace *OLD*</> and <literal>shoelace *NEW*</>.  These entries don't
@@ -539,9 +539,9 @@ SELECT shoelace.sl_name, shoelace.sl_avail,
      executor will still check that the user has proper privileges to access
      the view, even though there's no direct use of the view in the rewritten
      query.
-</Para>
+</para>
 
-<Para>
+<para>
     That was the first rule applied.  The rule system will continue checking
     the remaining range-table entries in the top query (in this example there
     are no more), and it will recursively check the range-table entries in
@@ -550,40 +550,40 @@ SELECT shoelace.sl_name, shoelace.sl_avail,
     In this example, there are no rewrite rules for <literal>shoelace_data</> or <literal>unit</>,
     so rewriting is complete and the above is the final result given to
     the planner.
-</Para>
+</para>
 
-<Para>
+<para>
     No we want to write a query that finds out for which shoes currently in the store
     we have the matching shoelaces (color and length) and where the
     total number of exactly matching pairs is greater or equal to two.
 
-<ProgramListing>
-SELECT * FROM shoe_ready WHERE total_avail >= 2;
+<programlisting>
+SELECT * FROM shoe_ready WHERE total_avail &gt;= 2;
 
  shoename | sh_avail | sl_name | sl_avail | total_avail
 ----------+----------+---------+----------+-------------
  sh1      |        2 | sl1     |        5 |           2
  sh3      |        4 | sl7     |        7 |           4
 (2 rows)
-</ProgramListing>
-</Para>
+</programlisting>
+</para>
 
-<Para>
+<para>
     The output of the parser this time is the query tree
 
-<ProgramListing>
+<programlisting>
 SELECT shoe_ready.shoename, shoe_ready.sh_avail,
        shoe_ready.sl_name, shoe_ready.sl_avail,
        shoe_ready.total_avail
   FROM shoe_ready shoe_ready
- WHERE shoe_ready.total_avail >= 2;
-</ProgramListing>
+ WHERE shoe_ready.total_avail &gt;= 2;
+</programlisting>
 
     The first rule applied will be the one for the 
     <literal>shoe_ready</literal> view and it results in the
     query tree
 
-<ProgramListing>
+<programlisting>
 SELECT shoe_ready.shoename, shoe_ready.sh_avail,
        shoe_ready.sl_name, shoe_ready.sl_avail,
        shoe_ready.total_avail
@@ -594,16 +594,16 @@ SELECT shoe_ready.shoename, shoe_ready.sh_avail,
                min(rsh.sh_avail, rsl.sl_avail) AS total_avail
           FROM shoe rsh, shoelace rsl
          WHERE rsl.sl_color = rsh.slcolor
-           AND rsl.sl_len_cm >= rsh.slminlen_cm
-           AND rsl.sl_len_cm <= rsh.slmaxlen_cm) shoe_ready
- WHERE shoe_ready.total_avail >= 2;
-</ProgramListing>
+           AND rsl.sl_len_cm &gt;= rsh.slminlen_cm
+           AND rsl.sl_len_cm &lt;= rsh.slmaxlen_cm) shoe_ready
+ WHERE shoe_ready.total_avail &gt;= 2;
+</programlisting>
 
     Similarly, the rules for <literal>shoe</literal> and
     <literal>shoelace</literal> are substituted into the range table of
     the subquery, leading to a three-level final query tree:
 
-<ProgramListing>
+<programlisting>
 SELECT shoe_ready.shoename, shoe_ready.sh_avail,
        shoe_ready.sl_name, shoe_ready.sl_avail,
        shoe_ready.total_avail
@@ -631,10 +631,10 @@ SELECT shoe_ready.shoename, shoe_ready.sh_avail,
                   FROM shoelace_data s, unit u
                  WHERE s.sl_unit = u.un_name) rsl
          WHERE rsl.sl_color = rsh.slcolor
-           AND rsl.sl_len_cm >= rsh.slminlen_cm
-           AND rsl.sl_len_cm <= rsh.slmaxlen_cm) shoe_ready
- WHERE shoe_ready.total_avail > 2;
-</ProgramListing>
+           AND rsl.sl_len_cm &gt;= rsh.slminlen_cm
+           AND rsl.sl_len_cm &lt;= rsh.slmaxlen_cm) shoe_ready
+ WHERE shoe_ready.total_avail &gt; 2;
+</programlisting>
    </para>
 
    <para>
@@ -650,8 +650,8 @@ SELECT shoe_ready.shoename, shoe_ready.sh_avail,
     system doesn't have to concern itself with.
    </para>
 
-   <Note>
-    <Para>
+   <note>
+    <para>
     There is currently no recursion stopping mechanism for view rules
     in the rule system (only for the other kinds of rules).  This
     doesn't hurt much, because the only way to push this into an
@@ -662,20 +662,20 @@ SELECT shoe_ready.shoename, shoe_ready.sh_avail,
     never happen if <command>CREATE VIEW</command> is used because for
     the first <command>CREATE VIEW</command>, the second relation does
     not exist and thus the first view cannot select from the second.
-    </Para>
-   </Note>
-</Sect2>
+    </para>
+   </note>
+</sect2>
 
-<Sect2>
-<Title>View Rules in Non-<command>SELECT</command> Statements</Title>
+<sect2>
+<title>View Rules in Non-<command>SELECT</command> Statements</title>
 
-<Para>
+<para>
     Two details of the query tree aren't touched in the description of
     view rules above. These are the command type and the result relation.
     In fact, view rules don't need this information.
-</Para>
+</para>
 
-<Para>
+<para>
     There are only a few differences between a query tree for a
     <command>SELECT</command> and one for any other
     command. Obviously, they have a different command type and for a
@@ -685,41 +685,41 @@ SELECT shoe_ready.shoename, shoe_ready.sh_avail,
     <literal>t1</> and <literal>t2</> with columns <literal>a</> and
     <literal>b</>, the query trees for the two statements
 
-<ProgramListing>
+<programlisting>
 SELECT t2.b FROM t1, t2 WHERE t1.a = t2.a;
 
 UPDATE t1 SET b = t2.b WHERE t1.a = t2.a;
-</ProgramListing>
+</programlisting>
 
     are nearly identical.  In particular:
 
-    <ItemizedList>
-        <ListItem>
-        <Para>
+    <itemizedlist>
+        <listitem>
+        <para>
             The range tables contain entries for the tables <literal>t1</> and <literal>t2</>.
-        </Para>
-        </ListItem>
+        </para>
+        </listitem>
 
-        <ListItem>
-        <Para>
+        <listitem>
+        <para>
             The target lists contain one variable that points to column
             <literal>b</> of the range table entry for table <literal>t2</>.
-        </Para>
-        </ListItem>
+        </para>
+        </listitem>
 
-        <ListItem>
-        <Para>
+        <listitem>
+        <para>
             The qualification expressions compare the columns <literal>a</> of both
             range-table entries for equality.
-        </Para>
-        </ListItem>
+        </para>
+        </listitem>
 
-        <ListItem>
-        <Para>
+        <listitem>
+        <para>
             The join trees show a simple join between <literal>t1</> and <literal>t2</>.
-        </Para>
-        </ListItem>
-    </ItemizedList>
+        </para>
+        </listitem>
+    </itemizedlist>
    </para>
 
    <para>
@@ -729,16 +729,16 @@ UPDATE t1 SET b = t2.b WHERE t1.a = t2.a;
     the target list by the planner and the final query tree will read
     as
 
-<ProgramListing>
+<programlisting>
 UPDATE t1 SET a = t1.a, b = t2.b WHERE t1.a = t2.a;
-</ProgramListing>
+</programlisting>
 
     and thus the executor run over the join will produce exactly the
     same result set as a
 
-<ProgramListing>
+<programlisting>
 SELECT t1.a, t2.b FROM t1, t2 WHERE t1.a = t2.a;
-</ProgramListing>
+</programlisting>
     
     will do. But there is a little problem in
     <command>UPDATE</command>: The executor does not care what the
@@ -750,9 +750,9 @@ SELECT t1.a, t2.b FROM t1, t2 WHERE t1.a = t2.a;
     this is an <command>UPDATE</command>, and it knows that this
     result should go into table <literal>t1</>. But which of the rows that are
     there has to be replaced by the new row?
-</Para>
+</para>
 
-<Para>
+<para>
     To resolve this problem, another entry is added to the target list
     in <command>UPDATE</command> (and also in
     <command>DELETE</command>) statements: the current tuple ID
@@ -762,11 +762,11 @@ SELECT t1.a, t2.b FROM t1, t2 WHERE t1.a = t2.a;
     original row of <literal>t1</> to be updated.  After adding the <acronym>CTID</>
     to the target list, the query actually looks like
 
-<ProgramListing>
+<programlisting>
 SELECT t1.a, t2.b, t1.ctid FROM t1, t2 WHERE t1.a = t2.a;
-</ProgramListing>
+</programlisting>
     
-    Now another detail of <ProductName>PostgreSQL</ProductName> enters
+    Now another detail of <productname>PostgreSQL</productname> enters
     the stage. Old table rows aren't overwritten, and this
     is why <command>ROLLBACK</command> is fast. In an <command>UPDATE</command>,
     the new result row is inserted into the table (after stripping the
@@ -776,26 +776,26 @@ SELECT t1.a, t2.b, t1.ctid FROM t1, t2 WHERE t1.a = t2.a;
     and current transaction ID. Thus the old row is hidden, and after
     the transaction committed the vacuum cleaner can really move it
     out.
-</Para>
+</para>
 
-<Para>
+<para>
     Knowing all that, we can simply apply view rules in absolutely
     the same way to any command. There is no difference.
-</Para>
-</Sect2>
+</para>
+</sect2>
 
-<Sect2>
-<Title>The Power of Views in <ProductName>PostgreSQL</ProductName></Title>
+<sect2>
+<title>The Power of Views in <productname>PostgreSQL</productname></title>
 
-<Para>
+<para>
     The above demonstrates how the rule system incorporates view
     definitions into the original query tree. In the second example, a
     simple <command>SELECT</command> from one view created a final
     query tree that is a join of 4 tables (<literal>unit</> was used twice with
     different names).
-</Para>
+</para>
 
-<Para>
+<para>
     The benefit of implementing views with the rule system is,
     that the planner has all
     the information about which tables have to be scanned plus the
@@ -807,16 +807,16 @@ SELECT t1.a, t2.b, t1.ctid FROM t1, t2 WHERE t1.a = t2.a;
     The planner has to decide which is
     the best path to execute the query, and the more information
     the planner has, the better this decision can be. And
-    the rule system as implemented in <ProductName>PostgreSQL</ProductName>
+    the rule system as implemented in <productname>PostgreSQL</productname>
     ensures, that this is all information available about the query
     up to that point.
-</Para>
-</Sect2>
+</para>
+</sect2>
 
-<Sect2 id="rules-views-update">
-<Title>Updating a View</Title>
+<sect2 id="rules-views-update">
+<title>Updating a View</title>
 
-<Para>
+<para>
     What happens if a view is named as the target relation for an
     <command>INSERT</command>, <command>UPDATE</command>, or
     <command>DELETE</command>?  After doing the substitutions
@@ -824,18 +824,18 @@ SELECT t1.a, t2.b, t1.ctid FROM t1, t2 WHERE t1.a = t2.a;
     relation points at a subquery range-table entry.  This will not
     work, so the rewriter throws an error if it sees it has produced
     such a thing.
-</Para>
+</para>
 
-<Para>
+<para>
     To change this, we can define rules that modify the behavior of
     these kinds of commands. This is the topic of the next section.
-</Para>
-</Sect2>
+</para>
+</sect2>
 
-</Sect1>
+</sect1>
 
-<Sect1 id="rules-update">
-<Title>Rules on <command>INSERT</>, <command>UPDATE</>, and <command>DELETE</></Title>
+<sect1 id="rules-update">
+<title>Rules on <command>INSERT</>, <command>UPDATE</>, and <command>DELETE</></title>
 
 <indexterm zone="rules-update">
  <primary>rule</primary>
